<?php
class DB {

	public function getPossibleDB()
	{
		$php_exts = get_loaded_extensions();
		$dbs = array();
		if(in_array('mysql', $php_exts)) $dbs[] = 'MySQL';
		if(in_array('pgsql', $php_exts)) $dbs[] = 'Postgre';
		if(in_array('mssql', $php_exts)) $dbs[] = 'MsSQL';
		if(in_array('oci8', $php_exts)) $dbs[] = 'Oracle';
		return $dbs;
	}
	
	public function getDefDBSettings($db=null)
	{
		$default_DBs_settings = array('MySQL' => array('db_port'=>'3306',
														 'db_name'=>'sampledb',
														 'db_user'=>'root'),
									  'Postgre' => array('db_port'=>'5432',
														 'db_name'=>'sampledb',
														 'db_user'=>'postgres'),
									  'MsSQL' => array('db_port'=>'1541',
													   'db_name'=>'sampledb',
													   'db_user'=>'sa'),
									  'Oracle' => array('db_port'=>'1521',
														'db_name'=>'',
														'db_user'=>'system'));
		return ($db)? $default_DBs_settings[$db] : $default_DBs_settings;
	}
	
	public function connect($db='', $db_host='', $db_port='', $db_user='', $db_pass='', $db_name='')
	{
		$db = ($db)? $db : $_SESSION["db"];
		$db_host = ($db_host)? $db_host : $_SESSION["db_host"];
		$db_port = ($db_port)? $db_port : $_SESSION["db_port"];
		$db_user = ($db_user)? $db_user : $_SESSION["db_user"];
		$db_pass = ($db_pass)? $db_pass : $_SESSION["db_pass"];
		$db_name = ($db_name)? $db_name : $_SESSION["db_name"];
		switch($db)
		{
			case 'MySQL':
				@$link = mysql_connect($db_host.':'.$db_port, $db_user, $db_pass);
				if ($link) $db_select = mysql_select_db($db_name, $link);
				if (!$db_select) $link = false;
				break;
			case 'Postgre':
				@$link = pg_connect('host='.$db_host.' port='.$db_port.' dbname='.$db_name.' user='.$db_user.' password='.$db_pass);
				break;
			case 'MsSQL':
				$db_host = ($db_port)? $db_host.':'.$db_port : $db_host;
				@$link = mssql_connect($db_host, $db_user, $db_pass);
				if ($link) $db_select = mssql_select_db($db_name, $link);
				if (!$db_select) $link = false;
			break;
			case 'Oracle':
				$db_host = ($db_port)? $db_host.':'.$db_port : $db_host;
				@$link = oci_connect($db_user, $db_pass, $db_host);
			break;
			
		}
		return $link;
	}
	
	public function getTables(&$error_msg)
	{
		$tables = array();
		if ($link = DB::connect())
		{
			switch($_SESSION["db"])
			{
				case 'MySQL':
					$query = 'SHOW TABLES FROM `'.mysql_real_escape_string($_SESSION["db_name"]).'`';
					$result = mysql_query($query);
					while ($row = mysql_fetch_array($result, MYSQL_NUM)) $tables[]= $row[0];
					mysql_close($link);
					break;
				case 'Postgre':
					$query = "SELECT table_name FROM information_schema.tables WHERE table_schema = 'public' and table_type = 'BASE TABLE';";
					$result = pg_query($link, $query);
					while($row = pg_fetch_row($result)) $tables[]= $row[0];
					pg_close($link);
					break;
				case 'MsSQL':
					$query = "SELECT TABLE_NAME FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_TYPE = 'BASE TABLE';";
					$result = mssql_query($query, $link);
					while($row = mssql_fetch_row($result)) $tables[]= $row[0];
					mssql_close($link);
					break;
				case 'Oracle':
					$stid = oci_parse($link, 'select * from tab');
					oci_execute($stid);
					while ($row = oci_fetch_array($stid, OCI_NUM)) $tables[]= $row[0];
					oci_close($link);
					break;
			}
			if (sizeof($tables) == 0) $error_msg.= LOC_DB_ERR1."<br>";
		}else $error_msg.= LOC_DB_ERR2."<br>";
		
		return $tables;
	}
	
	public function getFields(&$error_msg)
	{
		$fields = array();
		if ($link = DB::connect())
		{
			switch($_SESSION["db"])
			{
				case 'MySQL':
					$query = 'SHOW COLUMNS FROM `'.mysql_real_escape_string($_SESSION["db_table"]).'`;';
					$result = mysql_query($query);
					if ($result)
					{
						$fields = array();
						while ($row = mysql_fetch_array($result, MYSQL_NUM)) $fields[] = $row[0];
						mysql_close($link);
					}
					else
					{
						$error_msg.= LOC_DB_ERR3."<br>";
					}
					break;
          		case 'Postgre':
					$query = "SELECT column_name FROM information_schema.columns WHERE table_name ='".$_SESSION["db_table"]."'";
					$result = pg_query($link, $query);
					while($row = pg_fetch_row($result)) $fields[] = $row[0];
					pg_close($link);
					break;
				case 'MsSQL':
					$query = "SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = '".$_SESSION["db_table"]."'";
					$result = mssql_query($query, $link);
					while($row = mssql_fetch_row($result)) $fields[]= $row[3];
					mssql_close($link);
					break;
				case 'Oracle':
					$stid = oci_parse($link, "SELECT column_name FROM user_tab_cols WHERE table_name=UPPER('".$_SESSION["db_table"]."')");
					oci_execute($stid);
					while ($row = oci_fetch_array($stid, OCI_NUM)) $fields[]= $row[0];
					oci_close($link);
					break;
			};
			if (sizeof($fields)==0) $error_msg.= "<br>";
		}else $error_msg.= LOC_DB_ERR2."<br>";
		
		return $fields;
	}
	
	public function getAutoIncField(&$error_msg)
	{
		if ($link = DB::connect())
		{
			switch($_SESSION["db"])
			{
				case 'MySQL':
				/*
					$query = 'SHOW COLUMNS FROM `'.mysql_real_escape_string($_SESSION["db_table"]).'`;';
					$result = mysql_query($query);
					if ($result)
					{
						$auto_inc_field = find_autoincrement($_SESSION["db_table"]);
						$field = "";
						$query = 'SHOW CREATE TABLE `'.mysql_real_escape_string($table_name).'`;';
						$result = mysql_query($query);
						$row = mysql_fetch_array($result, MYSQL_NUM);
						foreach (explode(",",$row[1]) as $val)
						{
							if (preg_match("/\`(.+)\`(.*)AUTO_INCREMENT/Ui",$val,$res))
							{
							  $auto_inc_field = $res[1];
							}
						}
						mysql_close($link);
					}
					*/
					$fields = mysql_list_fields($_SESSION["db_name"], $_SESSION["db_table"]);
					if(mysql_num_fields($fields)) {
						for ($i = 0; $i < mysql_num_fields($fields); $i++) {
							$flags = mysql_field_flags($fields, $i);
							if (strpos($flags, 'auto_increment')!==false) $auto_inc_field = mysql_field_name($fields, $i);
						}
					}
					else {
						$error_msg.= LOC_DB_ERR4."<br>";
					}
					break;
				case 'Postgre':
					$query = "SELECT columns.column_name FROM information_schema.columns WHERE columns.table_name='".$_SESSION["db_table"]."' AND columns.column_default LIKE '%nextval%'";
					$result = pg_query($link, $query);
					while($row = pg_fetch_row($result)) $auto_inc_field = $row[0];
					pg_close($link);
					break;
					
				case 'MsSQL':
					$query = "SELECT c.name AS column_name
								FROM sys.columns AS c 
								WHERE is_identity = 1 
									AND object_id = OBJECT_ID('".$_SESSION["db_table"]."');";
					$result = mssql_query($query);
					while($row = mssql_fetch_row($result)) $auto_inc_field= $row[0];
					break;
			}
			if (!$auto_inc_field) $error_msg.= LOC_DB_ERR5."<br>";
		}else $error_msg.= LOC_DB_ERR2."<br>";
		return $auto_inc_field;
	}
	
	public function getSequences(&$error_msg)
	{
		if ($link = DB::connect())
		{
			$stid = oci_parse($link, "SELECT SEQUENCE_NAME FROM USER_SEQUENCES");
			oci_execute($stid);
			while ($row = oci_fetch_array($stid, OCI_NUM)) $sequences[]= $row[0];
			oci_close($link);
			
		}else $error_msg.= LOC_DB_ERR2."<br>";
		return $sequences;
	}
}
?>