<?php
session_start ();

header("Expires: Mon, 26 Jul 1997 05:00:00 GMT"); // Datum aus Vergangenheit
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
header("Cache-Control: no-store, no-cache, must-revalidate");
header("Cache-Control: post-check=0, pre-check=0", false);
header("Pragma: no-cache"); 


define("DB_CONFIG_FILE", "conf/db_config.ini");

if (!file_exists(DB_CONFIG_FILE))
{
    if (file_exists("install/index.php"))
    {
        // RUN INSTALLATOR
        header('Location: install/index.php?db_conf=1');
    }
    else
    {
		require_once("langs/english.php");
        echo "<b>".LOC_ADMIN_ERR1."</b>";
        die();
    }
}

if (!isset($_SESSION["page"]))
{
  $_SESSION["page"] = "main";
}

$ini_array = parse_ini_file(DB_CONFIG_FILE, true);
require_once('langs/'.$ini_array["language"]["language_file"]);

// incoming key
$_SESSION["key"] = isset($_GET["key"]) ? $_GET["key"] : (isset($_SESSION["key"]) ? $_SESSION["key"] : "");

$full_access = ($_SESSION["key"] == $ini_array["access_key"]["access_key"]);

require_once('langs/'.$ini_array["language"]["language_file"]);

$title  = LOC_ADMIN_TITLE;

function dbg ($obj)
{
  print "<pre>";
  print_r ($obj);
  print "</pre>";
}

function button($type)
{
	switch($type) {
		case "delete":
    		return '<input onclick="if (is_checked(\'grid_conf_file\')) { if (confirm(\''.LOC_ADMIN_MSG1.'\')) {return true;} else {return false;}}" class="button btn_'.$type.'" type="submit" name="'.$type.'" value="'.LOC_BTN_DELETE.'">';
			break;
  		case "save":
    		return '<input onclick="if (confirm(\''.LOC_ADMIN_MSG2.'\')) {return true;} else {return false;}" class="button btn_'.$type.'" type="submit" name="'.$type.'" value="'.LOC_BTN_SAVE.'">';
			break;
  		case "admin_mode":
    		return '<input class="button btn_'.$type.'" type="submit" name="'.$type.'" value="'.LOC_BTN_ADMIN_MODE.'">';
			break;
  		case "add":
			return '<input class="button btn_'.$type.'" type="submit" name="'.$type.'" value="'.LOC_BTN_ADD.'">';
			break;
  		case "pages_management":
   			return '<input class="button btn_'.$type.'" type="submit" name="'.$type.'" value="'.LOC_BTN_PUBLIC_PAGES.'">';
			break;
  		case "configure":
			return '<input class="button btn_'.$type.'" type="submit" name="'.$type.'" value="'.LOC_BTN_CONFIG.'">';
			break;
    	case "guest_mode":
    		return '<input class="button btn_'.$type.'" type="submit" name="'.$type.'" value="'.LOC_BTN_GUEST_MODE.'">';
			break;
		case "back":
    		return '<input class="button btn_'.$type.'" type="submit" name="'.$type.'" value="'.LOC_BTN_BACK.'">';
			break;
		case "cancel":
    		return '<input class="button btn_'.$type.'" type="submit" name="'.$type.'" value="'.LOC_BTN_CANCEL.'">';
			break;
		default:
    		return '<input class="button btn_'.$type.'" type="submit" name="'.$type.'" value="&nbsp;">';
			break;
	}
}


switch ($_SESSION["page"])
{
    //==============================================================================================
    // MAIN
    //==============================================================================================
    
    case "main":

          $error_msg = "";
          
          $_SESSION["grid_conf_file"] = isset($_POST["grid_conf_file"]) ? $_POST["grid_conf_file"] : (isset($_SESSION["grid_conf_file"]) ? $_SESSION["grid_conf_file"] : "");
          
          
          if (isset($_POST["admin_mode"]))
          {
            $_SESSION["key"] = $_POST["key"];
            
            if ($_SESSION["key"] != $ini_array["access_key"]["access_key"])
            {
                $error_msg.= LOC_ADMIN_ERR2."<br>";
            }
            else
            {
                header('Location: index.php');
            }  
          }

          if (isset($_POST["guest_mode"]))
          {
            $_SESSION["key"] = "";
            header('Location: index.php');
          }
		  
		  if (isset($_POST["pages_management"]))
          {
            $_SESSION["page"] = "pages_management";
            header('Location: index.php');
          }

          if (isset($_POST["configure"]))
          {
            if ($_SESSION["grid_conf_file"]=="")
            {
                $error_msg.= LOC_ADMIN_ERR3."<br>";
            }
            else
            {
              $_SESSION["page"] = "configure";
              header('Location: index.php');
            }
          }

          // delete form and all files
          
          if (isset($_POST["delete"]))
          {
              if ($_SESSION["grid_conf_file"]=="")
              {
                  $error_msg.= LOC_ADMIN_ERR3."<br>";
              }
              else
              {
                  if (file_exists($_SESSION["grid_conf_file"]))
                  {
                      $ini = parse_ini_file($_SESSION["grid_conf_file"], true);
                      $grid_filename = $ini["grid_filename"]["grid_filename"];
                      preg_match("/^(.+)\.php$/Ui", $grid_filename, $tmp);
                      $name = $tmp[1];
                      if ($name!="")
                      {

                          $files_to_del = array();
                          $files_to_del[]= $_SESSION["grid_conf_file"];
                          $files_to_del[]= $grid_filename;
                          $files_to_del[]= $name.".log";
                          $files_to_del[]= $name."_connector.php";
                          
                          foreach ($files_to_del as $file_to_del)
                          {
                              if (file_exists($file_to_del))
                              {
                                  $res = @unlink($file_to_del);
                                  if (!$res)
                                  {
                                    $error_msg.= printf(LOC_ADMIN_ERR4, $file_to_del)."<br>";
                                  }
                              }
                              else
                              {
                                  // $error_msg.= "Can not delete file: '".$file_to_del."'  - file not found!<br>";
                              }
                          }

						  // Delete from public pages, if exist
						  $conf_file_ini = parse_ini_file(DB_CONFIG_FILE, true);
             			  $public_pages = $conf_file_ini["public_pages"]["public_pages"];
						  if(strpos($public_pages, $grid_filename)!==false)
						  {
							  $public_pages = explode(',', $public_pages);
							  foreach($public_pages as $k=>$fav_page) if($fav_page == $grid_filename) unset($public_pages[$k]);
							  $conf_file = file(DB_CONFIG_FILE);
							  foreach($conf_file as &$file_line)
							  {
								  if(strpos($file_line, 'public_pages =')!==false)
								  {
									  $file_line = 'public_pages = "'.implode(',', $public_pages).'"';
								  }
							  }
							  if ($f = fopen(DB_CONFIG_FILE, "w"))
							  {
								fwrite($f, implode("",$conf_file));
								fclose($f);
							  }
						  }
						  header('Location: index.php');
                      }                
                      else
                      {
                          $error_msg.= LOC_ADMIN_ERR5."<br>";
                      }
                      $_SESSION["grid_conf_file"] = "";
                  }
                  else
                  {
                      $error_msg.= LOC_ADMIN_ERR6."<br>";
                  }
              }
          }
          
          if (isset($_POST["add"]))
          {
              header('Location: install/index.php?form_conf=1&key='.$_SESSION["key"]);
              die();
          }
          
		  // Get public pages from config
		  $conf_file_ini = parse_ini_file(DB_CONFIG_FILE, true);
		  $f_pages = $conf_file_ini["public_pages"]["public_pages"];
		  $f_pages = explode(',', $f_pages);
        
          $links = $center_links = array();
          foreach (glob("conf/*.ini") as $conf_filename) 
          {
             if ($conf_filename == DB_CONFIG_FILE) continue;
             $ini = parse_ini_file($conf_filename, true);
             $grid_title    = $ini["grid_title"]["grid_title"];
             $grid_filename = $ini["grid_filename"]["grid_filename"];
			 // Show only allowed pages for public
			 if($full_access)
			 {
             	$links[] = '<p><input type="radio" name="grid_conf_file" value="'.$conf_filename.'" '.(($conf_filename == $_SESSION["grid_conf_file"]) ? "checked" : "").' /><a target="_blank" href="'.$grid_filename.($full_access ? "?key=".$_SESSION["key"] : "").'">'.$grid_title.'</a></p>';
			 }
			 elseif(!$full_access&&in_array($grid_filename, $f_pages))
			 {
				$links[] = '<p><a target="_blank" href="'.$grid_filename.($full_access ? "?key=".$_SESSION["key"] : "").'">'.$grid_title.'</a></p>';
			 }
          }
          
          $content_left = '<div>'.LOC_PAGES.'</div>'.join("", $links);

          $content_right = '<div>'.($full_access ? LOC_ADMIN_MODE : LOC_GUEST_MODE).'</div>';          
          if ($full_access)
          {
            $content_right.= button("add").button("delete").button("pages_management").button("configure").button("guest_mode");
          }
          else
          {
            $content_right.= '<input id="key" type="text" name="key" value="'.$_SESSION["key"].'"/>'.button("admin_mode");
          }
          
          
          $content = '<div id="content_page_'.$_SESSION["page"].'">';
          $content.= '<form action="index.php" method="POST">';
          $content.= '<div class="content_left">'.$content_left.'</div>';
          $content.= '<div class="content_right">'.$content_right.'</div>';
          
          if ($error_msg!="")
          {
            $error_content = '<div id="admin_error_content"><div class="error_header">'.LOC_ERROR.'</div><div class="error_message">'.$error_msg.'</div></div>';
          }
          $content.= '</form></div>';
    
    break;
    
    //==============================================================================================
    // Pages Management
    //==============================================================================================
    case "pages_management":
	
		if (isset($_POST["save"]))
          {
			  $public_pages = $_POST['pages'];
			  $conf_file = file(DB_CONFIG_FILE);
			  foreach($conf_file as &$file_line)
			  {
				  if(strpos($file_line, 'public_pages =')!==false)
				  {
					  $file_line = 'public_pages = "'.@implode(',', $public_pages).'"';
				  }
			  }
			  if ($f = fopen(DB_CONFIG_FILE, "w"))
			  {
				fwrite($f, implode("",$conf_file));
				fclose($f);
			  }
			  $_SESSION["page"] = "main";
              header('Location: index.php');
		  }
		  
		  if (isset($_POST["back"]))
          {
            $_SESSION["page"] = "main";
            header('Location: index.php');
          }
		  
		  // Get public pages from config
		  $conf_file_ini = parse_ini_file(DB_CONFIG_FILE, true);
		  $f_pages = $conf_file_ini["public_pages"]["public_pages"];
		  $f_pages = explode(',', $f_pages);
        
          $links = array();
          foreach (glob("conf/*.ini") as $conf_filename) 
          {
             if ($conf_filename == DB_CONFIG_FILE) continue;
             $ini = parse_ini_file($conf_filename, true);
             $grid_title    = $ini["grid_title"]["grid_title"];
             $grid_filename = $ini["grid_filename"]["grid_filename"];
			 // Show only allowed pages for public
			 $links[] = '<p><input type="checkbox" name="pages['.$grid_filename.']" value="'.$grid_filename.'" '.((in_array($grid_filename, $f_pages))?'checked="checked"':'').' /><a target="_blank" href="'.$grid_filename.($full_access ? "?key=".$_SESSION["key"] : "").'">'.$grid_title.'</a></p>';
          }
		  
		  $content_left = '<div>'.LOC_PUBLIC_PAGE.'</div>'.join("", $links);
		  
		  $content = '<div id="content_page_'.$_SESSION["page"].'">';
          $content.= '<form action="index.php" method="POST">';
          $content.= '<div class="content_center">'.$content_left.'<div style="clear:both"></div></div>';
          
		  $content.= '<div>'.button("back").' '.button("save").'</div>';
          if ($error_msg!="")
          {
            $error_content = '<div id="admin_error_content"><div class="error_header">Error:</div><div class="error_message">'.$error_msg.'</div></div>';
          }
          $content.= '</form></div>';
    break;
    
    //==============================================================================================
    // configure
    //==============================================================================================
    
    case "configure":
          
          if (!$full_access)
          {
            die();
          }
          
          if (isset($_POST["save"]))
          {
            $config_content = htmlspecialchars_decode($_POST["config_content"], ENT_QUOTES);
            if (get_magic_quotes_gpc() == 1) $config_content = stripslashes($config_content);

            if ($f = fopen($_SESSION["grid_conf_file"], "w"))
            {
                fwrite($f, $config_content);
                fclose($f);
            }
            else
            {
                $error_msg.= printf(LOC_ADMIN_ERR7, $_SESSION["grid_conf_file"])."<br>";
            }
            
          
            $_SESSION["page"] = "main";
            header('Location: index.php');
          }

          if (isset($_POST["cancel"]))
          {
            $_SESSION["page"] = "main";
            header('Location: index.php');
          }

          $conf_content = htmlspecialchars(file_get_contents($_SESSION["grid_conf_file"]), ENT_QUOTES);
          
          $editor_content ='<span>Edit configuration:</span><span id="config_filename">'.$_SESSION["grid_conf_file"].'</span><textarea name="config_content">'.$conf_content.'</textarea>'.button("save").button("cancel");
          
          $content = '<div id="content_page_'.$_SESSION["page"].'">';
          $content.= '<form action="index.php" method="POST">';
          $content.= '<div class="editor">'.$editor_content.'</div>';
          
          if ($error_msg!="")
          {
            $error_content = '<div id="admin_error_content"><div class="error_header">Error:</div><div class="error_message">'.$error_msg.'</div></div>';
          }
          $content.= '</form></div>';
    
    break;

}


?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
 <head>
  <title><?php echo $title; ?></title>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  <link rel="stylesheet" type="text/css" href="files/admin.css" />
 </head>
 <script>
   function is_checked(name)
   {
      var pages = document.getElementsByName(name);
      for (var j = 0; j < pages.length; j++) 
      { 
          if (pages[j].checked) return true;
      }
      return false;
   }
 </script>
<body>
<center>
<div id="admin_main">
  <div id="admin_header">
    <div id="admin_header_left"></div>
    <div id="admin_header_right"></div>
  </div>
  <div id="admin_content"><?php echo $content; ?></div>
  <div id="admin_error"><?php echo $error_content; ?></div>
</div>
</center>
</body>
</html>