<?php

//==================================================================================================
// FUNCTIONS
//==================================================================================================

function button($type)
{
  switch ($type)
  {
    case "continue":
      return '<input class="continue-button" type="submit" name="next" value="'.LOC_BTN_CONTINUE.'">';
    break;
    case "back":
      return '<input class="back-button" type="submit" name="back" value="'.LOC_BTN_BACK.'">';
    break;
    case "clear":
      return '<input class="clear-button" type="submit" name="clear" value="'.LOC_BTN_CLEAR.'">';
    break;
    case "save":
      return '<input class="save-button" type="submit" name="next" value="'.LOC_BTN_SAVE_AND_FINISH.'"> ';
    break;
  }
  return "";
}

function rand_str($length = 32, $chars = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz1234567890')
{
    $chars_length = (strlen($chars) - 1);
    $string = $chars{rand(0, $chars_length)};
    for ($i = 1; $i < $length; $i = strlen($string))
    {
        $r = $chars{rand(0, $chars_length)};
        if ($r != $string{$i - 1}) $string .=  $r;
    }
    return $string;
}

function add_comment($config_data, $comment_array)
{
  $j = 0;
  while (isset($config_data["_COMMENT|".$j]) && ($j<100))
  {
    $j++;
  }
  $config_data["_COMMENT|".$j] = $comment_array;
  return $config_data;
}



function prepare_global_config_data()
{
  $config_data = array();
  $config_data = add_comment($config_data,  array ("This is a configuration file","Comments start with ';'"));
  $config_data = add_comment($config_data,  array ("Database configuration"));
  $config_data["database"] = array ("db"       => $_SESSION["db"],
									"db_host"  => $_SESSION["db_host"],
                                    "db_port"  => $_SESSION["db_port"],
                                    "db_name"  => $_SESSION["db_name"],
                                    "db_user"  => $_SESSION["db_user"],
                                    "db_pass"  => $_SESSION["db_pass"]
                                    );
  
  $config_data = add_comment($config_data,  array ("Access key"));
  $config_data["access_key"] = array ("access_key" => $_SESSION["access_key"]);
  $config_data["language"] = array ("language_file" => $_SESSION["lang"]);
  $config_data["public_pages"] = array ("public_pages" => '');
  return $config_data;
}



function prepare_config_data()
{
  $config_data = array();
  $config_data = add_comment($config_data,  array ("This is a configuration file","Comments start with ';'"));
  $config_data = add_comment($config_data,  array ("Database table"));
  $config_data["db_table"] = array ("db_table" => $_SESSION["db_table"]);
  
  $table = $_SESSION["db_table"];
  
  $config_data = add_comment($config_data,  array ("Autoincrement field (key) and sequence (only for Oracle)"));
  $config_data["autoincrement_field"] = array ("autoincrement_field" => $_SESSION["auto_inc_field"], "sequence" => $_SESSION["sequence"]);
  
  $config_data = add_comment($config_data,  array ("Grid title"));
  $config_data["grid_title"] = array ("grid_title" => $_SESSION["grid_title"]);

  $config_data = add_comment($config_data,  array ("Grid filename", "Do not change this!"));
  $config_data["grid_filename"] = array ("grid_filename" => $_SESSION["form_page_file"]);
  
  $config_data = add_comment($config_data,  array ("Header"));
  $config_data["header"] = array ("header" => $_SESSION["header"]);
  
  $config_data = add_comment($config_data,  array ("Footer"));
  $config_data["footer"] = array ("footer" => $_SESSION["footer"]);
  
  $config_data = add_comment($config_data,  array ("Fields configuration"));
  $count = 0;
  for ($j=0; $j<sizeof($_SESSION["fields"]); $j++)
  {
    if ($_SESSION["fields_checked"][$table][$j] == 1 && $_SESSION["fields"][$j]!=$_SESSION["auto_inc_field"])
    {
        $count++;
        $field = $_SESSION["fields"][$j];
        $config_data["field_".$count] = array ("field_name"  => $field,
                                               "title"  => htmlspecialchars($_SESSION["fields_info"][$table]["name"][$j]),
                                               "order"  => $_SESSION["fields_info"][$table]["order"][$j],
                                               "sort"   => $_SESSION["fields_info"][$table]["sort"][$j],
                                               "filter" => $_SESSION["fields_info"][$table]["filter"][$j],
                                               "type"   => $_SESSION["fields_info"][$table]["type"][$j]
                                               );
    }
  }
  return $config_data;
}


function get_form_config_filename($config_dir, $title, $reserved_names)
{
  $j = 1;
  $title = str_replace(" ","_",strtolower($title));
  
  if (in_array($title, $reserved_names)) $title = $title."_renamed";
  
  if (!file_exists($config_dir.$title.".ini"))
  {
      $conf_filename = $config_dir.$title.".ini";
  }
  else
  {
      while (file_exists($conf_filename = $config_dir.$title."_".$j.".ini") && $j<1000)
      {
          $j++;
      }
  }
  return $conf_filename;
}


function save_cofig($config_file, $config_data = array("section1" => array("var1" => "value1")))
{
    $dir = dirname($config_file);
    if ($dir!="" && !file_exists($dir))
    {
      return sprintf(LOC_INSTALL_ERR1,$dir);
    }
    
    if ($dir!="" && !is_writeable($dir))
    {
      return sprintf(LOC_INSTALL_ERR2,$dir);
    }
    
    @$f = fopen($config_file, "w");
    if (!$f)
    {
        return sprintf(LOC_INSTALL_ERR3,$dir);
    }
    else
    {
        foreach ($config_data as $section => $data)
        {
          if (strstr($section, "_COMMENT|"))
          {
              foreach ($data as $str)
              {
                if ($str[0]!= ';')
                {
                  $str = "; ".trim($str)."\n";
                }
                fwrite($f, $str);          
              }
          }
          else
          {
              fwrite($f, "[".preg_replace("/[\[\]]/Ui", "", $section)."]\n");
              foreach ($data as $key => $val)
              {
                fwrite($f, $key." = \"".$val."\"\n");
              }
              fwrite($f, "\n");
          }
          fwrite($f, "\n");
        }
        fclose($f);
    }
    return "";
}


function dbg ($obj)
{
  print "<pre>";
  print_r ($obj);
  print "</pre>";
}

function find_autoincrement($table_name)
{
     $field = "";
     $query = 'SHOW CREATE TABLE `'.mysql_real_escape_string($table_name).'`;';
     $result = mysql_query($query);
     $row = mysql_fetch_array($result, MYSQL_NUM);
     foreach (explode(",",$row[1]) as $val)
     {
        if (preg_match("/\`(.+)\`(.*)AUTO_INCREMENT/Ui",$val,$res))
        {
          $field = $res[1];
        }
     }
     return ($field!="") ? $field : false;
}
?>